var Est97000_PercentualDivergenciasInventarioCego_Services = function(General) {
    // Gets logged unit
    this.getFilialLogada = function() {
        const filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
	    ];
        return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };

    // checks and Builds dataSet
    this.onCheckDataset = (row) => new Promise((resolve) => {
        let dataSet = [];
        let count = 0;
        const { CDFILIAL: Unities, CDPRODUTO, VRPERDIVESTCEG } = row;
        const getProductInfo = (unity) => {
            const filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": unity
                },
                {
                    "name": "CDPRODUTO",
                    "operator": "=",
                    "value": CDPRODUTO
                }
	        ];
            return General.callRestEngine('est#/crud/parperdivestceg', 'FilterData', filter).then((success) => {
                return success.dataset.parperdivestceg.length != 0 ? false : true;
            });
        };

        Unities.forEach((unity) => {
            getProductInfo(unity).then((newProduct) => {
                let newIndex = {
                    "__is_new": newProduct,
                    "changed": !newProduct,
                    "CDFILIAL": unity,
                    "CDPRODUTO": CDPRODUTO,
                    "VRPERDIVESTCEG": VRPERDIVESTCEG
                };
                dataSet.push(newIndex);
                count++;
                if (count === Unities.length) return resolve(dataSet);
            });
        });
        return Promise;
    });
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Est97000_PercentualDivergenciasInventarioCego_Services', Est97000_PercentualDivergenciasInventarioCego_Services);
});
